function roots = computeroots(c)
% function to compute the roots of a polynomial using eigenvalues
% input : c      vector 1xp+1 where $p$ is the order of the polynomial
% output: roots  p roots of the polynomial


% It is well known that we can compute using a exact formula the roots of
% polynomials up to degree 5. For polynomials above degree 5, one can use
% Galois Theory to prove that such formula do not exist.

% Moreover, computing roots of polynomials is in general hard, some
% iterative methods issues from optimization techniques can easily give you
% one root, but they need to be specifically re-started in order to provide
% all the roots. 

% Numerically, the typical algorithm is to use the link between
% characteristical polynomial and eigenvalues. 
% 
% In this case the polynomial is given by its coefficients stored in the
% input array c such that 
% c(1)*x^p + ... + c(p)*x + c(p+1)

% in this cas you will build a matrix pxp, such that its charactiristic
% polynomial is given by the polynomial above.

% order of the polynomial
p = length(c);

% In this case you need to find a matrix such that its characteristic 
% polynomial matches the polynomial generated by the coefficients in c 
% (such matrix is normally called the companion matrix, and a quick google
% search will give you the corerct form of the matrix).

% you will assemble the companion matrix
M = 

% Once the matrix is assembled you will compute its eigenvalues using the 
% built-in function eig, and the corresponding eigenvalues are indeed 
% the roots of the polynomial whose coefficients are given by c

[roots, ~] = eig(M);
end